'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transposeVTree = undefined;

var _rx = require('rx');

var _rx2 = _interopRequireDefault(_rx);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function transposeVTree(vTree) {
  if (typeof vTree.data === 'object' && vTree.data.static) {
    return _rx2.default.Observable.just(vTree);
  } else if (!vTree) {
    return null;
  } else if (typeof vTree.subscribe === 'function') {
    return vTree.flatMapLatest(transposeVTree);
  } else if (typeof vTree === 'object') {
    if (vTree.children && vTree.children.length > 0) {
      return _rx2.default.Observable.combineLatest(vTree.children.map(transposeVTree).filter(function (x) {
        return !!x;
      }), function () {
        for (var _len = arguments.length, children = Array(_len), _key = 0; _key < _len; _key++) {
          children[_key] = arguments[_key];
        }

        return {
          sel: vTree.sel,
          data: vTree.data,
          text: vTree.text,
          elm: vTree.elm,
          key: vTree.key,
          children: children
        };
      });
    }
    return _rx2.default.Observable.just(vTree);
  } else {
    throw new Error('Unhandled vTree Value');
  }
}

exports.transposeVTree = transposeVTree;